/* GeoLocate.c generated by valac 0.48.19, the Vala compiler
 * generated from GeoLocate.vala, do not modify */

/*
* Copyright (c) 2017-2018 Carlos Suárez (https://gitlab.com/bitseater)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; If not, see <http://www.gnu.org/licenses/>.
*
* Authored by: Carlos Suárez <bitseater@gmail.com>
*/

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <gio/gio.h>
#include <libsoup/soup.h>
#include <json-glib/json-glib.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>

#define METEO_UTILS_TYPE_COORD (meteo_utils_coord_get_type ())
typedef struct _MeteoUtilsCoord MeteoUtilsCoord;

#define METEO_UTILS_TYPE_GEO_LOC (meteo_utils_geo_loc_get_type ())
typedef struct _MeteoUtilsGeoLoc MeteoUtilsGeoLoc;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_SoupBuffer_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupBuffer_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MeteoUtilsCoord {
	gdouble lat;
	gdouble lon;
};

struct _MeteoUtilsGeoLoc {
	gchar* city;
	gchar* state;
	gchar* country;
};

GType meteo_utils_coord_get_type (void) G_GNUC_CONST;
MeteoUtilsCoord* meteo_utils_coord_dup (const MeteoUtilsCoord* self);
void meteo_utils_coord_free (MeteoUtilsCoord* self);
GType meteo_utils_geo_loc_get_type (void) G_GNUC_CONST;
MeteoUtilsGeoLoc* meteo_utils_geo_loc_dup (const MeteoUtilsGeoLoc* self);
void meteo_utils_geo_loc_free (MeteoUtilsGeoLoc* self);
void meteo_utils_geo_loc_copy (const MeteoUtilsGeoLoc* self,
                               MeteoUtilsGeoLoc* dest);
void meteo_utils_geo_loc_destroy (MeteoUtilsGeoLoc* self);
void meteo_utils_geolocate (void);
#define CONSTANTS_OWM_API_ADDR "http://api.openweathermap.org/data/2.5/"
void meteo_utils_get_location (MeteoUtilsCoord* result);
void meteo_utils_get_names (gdouble lat,
                            gdouble lon,
                            MeteoUtilsGeoLoc* result);
gint64 meteo_utils_update_id (const gchar* uri);
static void _vala_SoupBuffer_free (SoupBuffer* self);

MeteoUtilsCoord*
meteo_utils_coord_dup (const MeteoUtilsCoord* self)
{
	MeteoUtilsCoord* dup;
	dup = g_new0 (MeteoUtilsCoord, 1);
	memcpy (dup, self, sizeof (MeteoUtilsCoord));
	return dup;
}

void
meteo_utils_coord_free (MeteoUtilsCoord* self)
{
	g_free (self);
}

static GType
meteo_utils_coord_get_type_once (void)
{
	GType meteo_utils_coord_type_id;
	meteo_utils_coord_type_id = g_boxed_type_register_static ("MeteoUtilsCoord", (GBoxedCopyFunc) meteo_utils_coord_dup, (GBoxedFreeFunc) meteo_utils_coord_free);
	return meteo_utils_coord_type_id;
}

GType
meteo_utils_coord_get_type (void)
{
	static volatile gsize meteo_utils_coord_type_id__volatile = 0;
	if (g_once_init_enter (&meteo_utils_coord_type_id__volatile)) {
		GType meteo_utils_coord_type_id;
		meteo_utils_coord_type_id = meteo_utils_coord_get_type_once ();
		g_once_init_leave (&meteo_utils_coord_type_id__volatile, meteo_utils_coord_type_id);
	}
	return meteo_utils_coord_type_id__volatile;
}

void
meteo_utils_geo_loc_copy (const MeteoUtilsGeoLoc* self,
                          MeteoUtilsGeoLoc* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	_tmp0_ = (*self).city;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).city);
	(*dest).city = _tmp1_;
	_tmp2_ = (*self).state;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).state);
	(*dest).state = _tmp3_;
	_tmp4_ = (*self).country;
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 ((*dest).country);
	(*dest).country = _tmp5_;
}

void
meteo_utils_geo_loc_destroy (MeteoUtilsGeoLoc* self)
{
	_g_free0 ((*self).city);
	_g_free0 ((*self).state);
	_g_free0 ((*self).country);
}

MeteoUtilsGeoLoc*
meteo_utils_geo_loc_dup (const MeteoUtilsGeoLoc* self)
{
	MeteoUtilsGeoLoc* dup;
	dup = g_new0 (MeteoUtilsGeoLoc, 1);
	meteo_utils_geo_loc_copy (self, dup);
	return dup;
}

void
meteo_utils_geo_loc_free (MeteoUtilsGeoLoc* self)
{
	meteo_utils_geo_loc_destroy (self);
	g_free (self);
}

static GType
meteo_utils_geo_loc_get_type_once (void)
{
	GType meteo_utils_geo_loc_type_id;
	meteo_utils_geo_loc_type_id = g_boxed_type_register_static ("MeteoUtilsGeoLoc", (GBoxedCopyFunc) meteo_utils_geo_loc_dup, (GBoxedFreeFunc) meteo_utils_geo_loc_free);
	return meteo_utils_geo_loc_type_id;
}

GType
meteo_utils_geo_loc_get_type (void)
{
	static volatile gsize meteo_utils_geo_loc_type_id__volatile = 0;
	if (g_once_init_enter (&meteo_utils_geo_loc_type_id__volatile)) {
		GType meteo_utils_geo_loc_type_id;
		meteo_utils_geo_loc_type_id = meteo_utils_geo_loc_get_type_once ();
		g_once_init_leave (&meteo_utils_geo_loc_type_id__volatile, meteo_utils_geo_loc_type_id);
	}
	return meteo_utils_geo_loc_type_id__volatile;
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result = NULL;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}

void
meteo_utils_geolocate (void)
{
	GSettings* setting = NULL;
	GSettings* _tmp0_;
	gchar* uri1 = NULL;
	gchar* _tmp1_;
	gchar* uri2 = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	MeteoUtilsCoord mycoords = {0};
	MeteoUtilsCoord _tmp6_ = {0};
	MeteoUtilsGeoLoc mygeoloc = {0};
	MeteoUtilsCoord _tmp7_;
	MeteoUtilsCoord _tmp8_;
	MeteoUtilsGeoLoc _tmp9_ = {0};
	gchar* uri = NULL;
	MeteoUtilsCoord _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	MeteoUtilsCoord _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	MeteoUtilsGeoLoc _tmp26_;
	const gchar* _tmp27_;
	MeteoUtilsGeoLoc _tmp28_;
	const gchar* _tmp29_;
	MeteoUtilsGeoLoc _tmp30_;
	const gchar* _tmp31_;
	_tmp0_ = g_settings_new ("com.gitlab.bitseater.meteo");
	setting = _tmp0_;
	_tmp1_ = g_strdup (CONSTANTS_OWM_API_ADDR "weather?lat=");
	uri1 = _tmp1_;
	_tmp2_ = g_settings_get_string (setting, "apiid");
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strconcat ("&APPID=", _tmp3_, NULL);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	uri2 = _tmp5_;
	meteo_utils_get_location (&_tmp6_);
	mycoords = _tmp6_;
	_tmp7_ = mycoords;
	_tmp8_ = mycoords;
	meteo_utils_get_names (_tmp7_.lat, _tmp8_.lon, &_tmp9_);
	mygeoloc = _tmp9_;
	_tmp10_ = mycoords;
	_tmp11_ = double_to_string (_tmp10_.lat);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_strconcat (uri1, _tmp12_, NULL);
	_tmp14_ = _tmp13_;
	_tmp15_ = g_strconcat (_tmp14_, "&lon=", NULL);
	_tmp16_ = _tmp15_;
	_tmp17_ = mycoords;
	_tmp18_ = double_to_string (_tmp17_.lon);
	_tmp19_ = _tmp18_;
	_tmp20_ = g_strconcat (_tmp16_, _tmp19_, NULL);
	_tmp21_ = _tmp20_;
	_tmp22_ = g_strconcat (_tmp21_, uri2, NULL);
	_tmp23_ = _tmp22_;
	_g_free0 (_tmp21_);
	_g_free0 (_tmp19_);
	_g_free0 (_tmp16_);
	_g_free0 (_tmp14_);
	_g_free0 (_tmp12_);
	uri = _tmp23_;
	_tmp24_ = g_strdup_printf ("%" G_GINT64_FORMAT, meteo_utils_update_id (uri));
	_tmp25_ = _tmp24_;
	g_settings_set_string (setting, "idplace", _tmp25_);
	_g_free0 (_tmp25_);
	_tmp26_ = mygeoloc;
	_tmp27_ = _tmp26_.city;
	g_settings_set_string (setting, "location", _tmp27_);
	_tmp28_ = mygeoloc;
	_tmp29_ = _tmp28_.state;
	g_settings_set_string (setting, "state", _tmp29_);
	_tmp30_ = mygeoloc;
	_tmp31_ = _tmp30_.country;
	g_settings_set_string (setting, "country", _tmp31_);
	_g_free0 (uri);
	meteo_utils_geo_loc_destroy (&mygeoloc);
	_g_free0 (uri2);
	_g_free0 (uri1);
	_g_object_unref0 (setting);
}

static void
_vala_SoupBuffer_free (SoupBuffer* self)
{
	g_boxed_free (soup_buffer_get_type (), self);
}

static gpointer
_json_object_ref0 (gpointer self)
{
	return self ? json_object_ref (self) : NULL;
}

void
meteo_utils_get_location (MeteoUtilsCoord* result)
{
	MeteoUtilsCoord coord = {0};
	gchar* uri = NULL;
	gchar* _tmp0_;
	SoupSession* session = NULL;
	SoupSession* _tmp1_;
	SoupMessage* message = NULL;
	const gchar* _tmp2_;
	SoupMessage* _tmp3_;
	SoupSession* _tmp4_;
	SoupMessage* _tmp5_;
	GError* _inner_error0_ = NULL;
	memset (&coord, 0, sizeof (MeteoUtilsCoord));
	_tmp0_ = g_strdup ("https://location.services.mozilla.com/v1/geolocate?key=test");
	uri = _tmp0_;
	_tmp1_ = soup_session_new ();
	session = _tmp1_;
	_tmp2_ = uri;
	_tmp3_ = soup_message_new ("GET", _tmp2_);
	message = _tmp3_;
	_tmp4_ = session;
	_tmp5_ = message;
	soup_session_send_message (_tmp4_, _tmp5_);
	{
		JsonParser* parser = NULL;
		JsonParser* _tmp6_;
		JsonParser* _tmp7_;
		SoupMessage* _tmp8_;
		SoupMessageBody* _tmp9_;
		SoupBuffer* _tmp10_;
		SoupBuffer* _tmp11_;
		guint8* _tmp12_;
		gint _tmp12__length1;
		JsonObject* root = NULL;
		JsonParser* _tmp13_;
		JsonNode* _tmp14_;
		JsonObject* _tmp15_;
		JsonObject* _tmp16_;
		JsonObject* _tmp17_;
		GList* _tmp18_;
		_tmp6_ = json_parser_new ();
		parser = _tmp6_;
		_tmp7_ = parser;
		_tmp8_ = message;
		_tmp9_ = _tmp8_->response_body;
		_tmp10_ = soup_message_body_flatten (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = _tmp11_->data;
		_tmp12__length1 = _tmp11_->length;
		json_parser_load_from_data (_tmp7_, (const gchar*) _tmp12_, (gssize) -1, &_inner_error0_);
		__vala_SoupBuffer_free0 (_tmp11_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (parser);
			goto __catch0_g_error;
		}
		_tmp13_ = parser;
		_tmp14_ = json_parser_get_root (_tmp13_);
		_tmp15_ = json_node_get_object (_tmp14_);
		_tmp16_ = _json_object_ref0 (_tmp15_);
		root = _tmp16_;
		_tmp17_ = root;
		_tmp18_ = json_object_get_members (_tmp17_);
		{
			GList* name_collection = NULL;
			GList* name_it = NULL;
			name_collection = _tmp18_;
			for (name_it = name_collection; name_it != NULL; name_it = name_it->next) {
				gchar* _tmp19_;
				gchar* name = NULL;
				_tmp19_ = g_strdup ((const gchar*) name_it->data);
				name = _tmp19_;
				{
					const gchar* _tmp20_;
					_tmp20_ = name;
					if (g_strcmp0 (_tmp20_, "location") == 0) {
						JsonObject* mycoords = NULL;
						JsonObject* _tmp21_;
						JsonObject* _tmp22_;
						JsonObject* _tmp23_;
						JsonObject* _tmp24_;
						JsonObject* _tmp25_;
						_tmp21_ = root;
						_tmp22_ = json_object_get_object_member (_tmp21_, "location");
						_tmp23_ = _json_object_ref0 (_tmp22_);
						mycoords = _tmp23_;
						_tmp24_ = mycoords;
						coord.lat = json_object_get_double_member (_tmp24_, "lat");
						_tmp25_ = mycoords;
						coord.lon = json_object_get_double_member (_tmp25_, "lng");
						_json_object_unref0 (mycoords);
						_g_free0 (name);
						break;
					} else {
						FILE* _tmp26_;
						_tmp26_ = stdout;
						fprintf (_tmp26_, "%s", _ ("Found an error"));
					}
					_g_free0 (name);
				}
			}
			(name_collection == NULL) ? NULL : (name_collection = (g_list_free (name_collection), NULL));
		}
		_json_object_unref0 (root);
		_g_object_unref0 (parser);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp27_ = e;
		_tmp28_ = _tmp27_->message;
		g_debug ("GeoLocate.vala:71: %s", _tmp28_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (message);
		_g_object_unref0 (session);
		_g_free0 (uri);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	*result = coord;
	_g_object_unref0 (message);
	_g_object_unref0 (session);
	_g_free0 (uri);
	return;
}

void
meteo_utils_get_names (gdouble lat,
                       gdouble lon,
                       MeteoUtilsGeoLoc* result)
{
	MeteoUtilsGeoLoc geoloc = {0};
	gchar* url = NULL;
	gchar* _tmp0_;
	gchar* uri = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	SoupSession* session = NULL;
	SoupSession* _tmp13_;
	SoupMessage* message = NULL;
	SoupMessage* _tmp14_;
	SoupMessageHeaders* _tmp15_;
	GError* _inner_error0_ = NULL;
	memset (&geoloc, 0, sizeof (MeteoUtilsGeoLoc));
	_tmp0_ = g_strdup ("https://nominatim.openstreetmap.org/reverse?format=json&zoom=10&");
	url = _tmp0_;
	_tmp1_ = g_strconcat (url, "lat=", NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = double_to_string (lat);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp2_, _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strconcat (_tmp6_, "&lon=", NULL);
	_tmp8_ = _tmp7_;
	_tmp9_ = double_to_string (lon);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_strconcat (_tmp8_, _tmp10_, NULL);
	_tmp12_ = _tmp11_;
	_g_free0 (_tmp10_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	uri = _tmp12_;
	_tmp13_ = soup_session_new ();
	session = _tmp13_;
	_tmp14_ = soup_message_new ("GET", uri);
	message = _tmp14_;
	_tmp15_ = message->request_headers;
	soup_message_headers_append (_tmp15_, "User-Agent", "com.gitlab.bitseater.meteo");
	soup_session_send_message (session, message);
	{
		JsonParser* parser = NULL;
		JsonParser* _tmp16_;
		SoupMessageBody* _tmp17_;
		SoupBuffer* _tmp18_;
		SoupBuffer* _tmp19_;
		guint8* _tmp20_;
		gint _tmp20__length1;
		JsonObject* root = NULL;
		JsonNode* _tmp21_;
		JsonObject* _tmp22_;
		JsonObject* _tmp23_;
		JsonObject* mygeoloc = NULL;
		JsonObject* _tmp24_;
		JsonObject* _tmp25_;
		JsonObject* _tmp26_;
		JsonObject* _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
		JsonObject* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		JsonObject* _tmp33_;
		const gchar* _tmp34_;
		gchar* _tmp35_;
		_tmp16_ = json_parser_new ();
		parser = _tmp16_;
		_tmp17_ = message->response_body;
		_tmp18_ = soup_message_body_flatten (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = _tmp19_->data;
		_tmp20__length1 = _tmp19_->length;
		json_parser_load_from_data (parser, (const gchar*) _tmp20_, (gssize) -1, &_inner_error0_);
		__vala_SoupBuffer_free0 (_tmp19_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (parser);
			goto __catch0_g_error;
		}
		_tmp21_ = json_parser_get_root (parser);
		_tmp22_ = json_node_get_object (_tmp21_);
		_tmp23_ = _json_object_ref0 (_tmp22_);
		root = _tmp23_;
		_tmp24_ = root;
		_tmp25_ = json_object_get_object_member (_tmp24_, "address");
		_tmp26_ = _json_object_ref0 (_tmp25_);
		mygeoloc = _tmp26_;
		_tmp27_ = mygeoloc;
		_tmp28_ = json_object_get_string_member (_tmp27_, "city");
		_tmp29_ = g_strdup (_tmp28_);
		_g_free0 (geoloc.city);
		geoloc.city = _tmp29_;
		_tmp30_ = mygeoloc;
		_tmp31_ = json_object_get_string_member (_tmp30_, "state");
		_tmp32_ = g_strdup (_tmp31_);
		_g_free0 (geoloc.state);
		geoloc.state = _tmp32_;
		_tmp33_ = mygeoloc;
		_tmp34_ = json_object_get_string_member (_tmp33_, "country_code");
		_tmp35_ = g_utf8_strup (_tmp34_, (gssize) -1);
		_g_free0 (geoloc.country);
		geoloc.country = _tmp35_;
		_json_object_unref0 (mygeoloc);
		_json_object_unref0 (root);
		_g_object_unref0 (parser);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp36_;
		const gchar* _tmp37_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp36_ = e;
		_tmp37_ = _tmp36_->message;
		g_debug ("GeoLocate.vala:94: %s", _tmp37_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (message);
		_g_object_unref0 (session);
		_g_free0 (uri);
		_g_free0 (url);
		meteo_utils_geo_loc_destroy (&geoloc);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	*result = geoloc;
	_g_object_unref0 (message);
	_g_object_unref0 (session);
	_g_free0 (uri);
	_g_free0 (url);
	return;
}

gint64
meteo_utils_update_id (const gchar* uri)
{
	SoupSession* session = NULL;
	SoupSession* _tmp0_;
	SoupMessage* message = NULL;
	SoupMessage* _tmp1_;
	gint64 id = 0LL;
	GError* _inner_error0_ = NULL;
	gint64 result = 0LL;
	g_return_val_if_fail (uri != NULL, 0LL);
	_tmp0_ = soup_session_new ();
	session = _tmp0_;
	_tmp1_ = soup_message_new ("GET", uri);
	message = _tmp1_;
	soup_session_send_message (session, message);
	id = (gint64) 0;
	{
		JsonParser* parser = NULL;
		JsonParser* _tmp2_;
		SoupMessageBody* _tmp3_;
		SoupBuffer* _tmp4_;
		SoupBuffer* _tmp5_;
		guint8* _tmp6_;
		gint _tmp6__length1;
		JsonObject* root = NULL;
		JsonNode* _tmp7_;
		JsonObject* _tmp8_;
		JsonObject* _tmp9_;
		JsonObject* _tmp10_;
		_tmp2_ = json_parser_new ();
		parser = _tmp2_;
		_tmp3_ = message->response_body;
		_tmp4_ = soup_message_body_flatten (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = _tmp5_->data;
		_tmp6__length1 = _tmp5_->length;
		json_parser_load_from_data (parser, (const gchar*) _tmp6_, (gssize) -1, &_inner_error0_);
		__vala_SoupBuffer_free0 (_tmp5_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (parser);
			goto __catch0_g_error;
		}
		_tmp7_ = json_parser_get_root (parser);
		_tmp8_ = json_node_get_object (_tmp7_);
		_tmp9_ = _json_object_ref0 (_tmp8_);
		root = _tmp9_;
		_tmp10_ = root;
		id = json_object_get_int_member (_tmp10_, "id");
		_json_object_unref0 (root);
		_g_object_unref0 (parser);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp11_ = e;
		_tmp12_ = _tmp11_->message;
		g_debug ("GeoLocate.vala:110: %s", _tmp12_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint64 _tmp13_ = -1LL;
		_g_object_unref0 (message);
		_g_object_unref0 (session);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp13_;
	}
	result = id;
	_g_object_unref0 (message);
	_g_object_unref0 (session);
	return result;
}

